%define bname		Bitcoin
%define consensus_major	0
%define libconsensus	%mklibname %{name}consensus %{consensus_major}
%define consensus_devel	%mklibname %{name}consensus -d

Summary:	%{bname} payment network
Name:		bitcoin
Version:	24.0.1
Release:	%mkrel 1
License:	MIT
Group:		Office/Finance
Url:		https://bitcoin.org/
Source0:	https://github.com/bitcoin/bitcoin/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:	bitcoin.service
Source3:	bitcoin.sysconfig
Source4:	bitcoin-tmpfiles.conf
Source5:	bitcoin-qt.desktop
Source6:	bitcoin-qt.protocol
BuildRequires:	boost-devel
BuildRequires:	miniupnpc-devel
BuildRequires:	pkgconfig(libqrencode)
BuildRequires:	pkgconfig(dbus-1)
BuildRequires:	pkgconfig(protobuf)
BuildRequires:	protobuf-compiler
BuildRequires:	pkgconfig(openssl)
BuildRequires:	pkgconfig(Qt5Core)
BuildRequires:	pkgconfig(Qt5DBus)
BuildRequires:	pkgconfig(Qt5Gui)
BuildRequires:	pkgconfig(Qt5Network)
BuildRequires:	pkgconfig(Qt5Widgets)
BuildRequires:	qttools5
BuildRequires:	pkgconfig(libssl)
BuildRequires:	pkgconfig(libcrypto)
BuildRequires:	pkgconfig(protobuf)
BuildRequires:	pkgconfig(libevent)
BuildRequires:	db-devel

%description
%{bname} is an innovative payment network and a new kind of money.

%package -n bitcoind
Summary:	%{bname} command line client
Group:		Office/Finance

%description -n bitcoind
bitcoind is the original %{bname} command line client.

%package qt
Summary:	%{bname} graphical Qt client
Group:		Office/Finance
Requires:	%{libconsensus} = %{version}

%description qt
%{bname}-Qt is the original %{bname} graphical client.

%package -n %{libconsensus}
Summary:	Shared libs for bitcoinconsensus
Group:		System/Libraries

%description -n %{libconsensus}
Shared libs for bitcoinconsensus.

%package -n %{consensus_devel}
Summary:	Development files for bitcoinconsensus
Group:		Development/C
Provides:	%{name}-devel = %{version}
Provides:	consensus-devel = %{version}
Requires:	%{libconsensus} = %{version}

%description -n %{consensus_devel}
This package contains development files for the bitcoinconsensus
library.

%prep
%autosetup -p1

%build
./autogen.sh
sed -i -e "s/void main/int main/g" configure
export CPPFLAGS="%{optflags} -I%{_includedir}/db53 -fPIC"
%configure \
    BDB_INCLUDE_PATH=%{_includedir}/db53 \
    --disable-static \
    --disable-silent-rules \
    --with-incompatible-bdb

# full parallel build seems to fail in Qt, so limite to -j4 level:
%__make -j4

%install
%make_install

rm -f %{buildroot}%{_bindir}/test_*
find %{buildroot} -name '*.la' -delete

mkdir -p %{buildroot}%{_localstatedir}/lib/bitcoin
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
install %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/%{name}
mkdir -p %{buildroot}%{_unitdir}
install -p -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}
install -D -p -m 0644 %{SOURCE4} %{buildroot}%{_tmpfilesdir}/%{name}.conf
install share/examples/bitcoin.conf %{buildroot}%{_sysconfdir}

for size in 16 32 64 128 256; do
  mkdir -p %{buildroot}%{_iconsdir}/hicolor/${size}x${size}/apps
  install -m644 share/pixmaps/bitcoin${size}.png %{buildroot}%{_iconsdir}/hicolor/${size}x${size}/apps/%{name}.png
done

mkdir -p %{buildroot}%{_datadir}/bash-completion/completions
install -m 0644 contrib/bitcoind.bash-completion %{buildroot}%{_datadir}/bash-completion/completions/%{name}d

mkdir -p %{buildroot}%{_datadir}/applications
install -m 0644 %{SOURCE5} %{buildroot}%{_datadir}/applications

mkdir -p %{buildroot}%{_datadir}/kservices5
install -m 0644 %{SOURCE6} %{buildroot}%{_datadir}/kservices5

%pre -n bitcoind
%_pre_useradd %{name} /dev/null /bin/false

%post -n bitcoind
if ! /usr/bin/id bitcoin &>/dev/null; then
       /usr/sbin/useradd -r -g bitcoin -s /bin/false -c "Bitcoin" -d /var/run/bitcoin bitcoin
fi
%_tmpfilescreate %{name}
%_post_service %{name}

%preun -n bitcoind
%_preun_service %{name}

%files -n bitcoind
%config (noreplace) %{_sysconfdir}/sysconfig/bitcoin
%config (noreplace) %{_sysconfdir}/bitcoin.conf
%dir %attr(0750, bitcoin, bitcoin) %{_localstatedir}/lib/bitcoin
%{_unitdir}/bitcoin.service
%{_tmpfilesdir}/bitcoin.conf
%{_bindir}/bitcoind
%{_bindir}/bitcoin-cli
%{_bindir}/bitcoin-tx
%{_bindir}/bitcoin-util
%{_bindir}/bitcoin-wallet
%{_bindir}/bench_bitcoin
%{_datadir}/bash-completion/completions/bitcoind
%{_mandir}/man1/bitcoin-cli.1*
%{_mandir}/man1/bitcoin-tx.1*
%{_mandir}/man1/bitcoind.1*
%{_mandir}/man1/bitcoin-util.1*
%{_mandir}/man1/bitcoin-wallet.1*

%files qt
%{_bindir}/%{name}-qt
%{_datadir}/applications/%{name}-qt.desktop
%{_datadir}/kservices5/%{name}-qt.protocol
%{_iconsdir}/hicolor/*/apps/%{name}.png
%{_mandir}/man1/bitcoin-qt.1.*

%files -n %{libconsensus}
%{_libdir}/lib%{name}consensus.so.%{consensus_major}{,.*}

%files -n %{consensus_devel}
%{_includedir}/%{name}consensus.h
%{_libdir}/lib%{name}consensus.so
%{_libdir}/pkgconfig/lib%{name}consensus.pc


%changelog
* Tue Dec 06 2022 kekepower <kekepower> 24.0.1-1.mga9
+ Revision: 1918685
- Update to version 24.0.1

* Thu Nov 17 2022 kekepower <kekepower> 24.0-1.mga9
+ Revision: 1908511
- Update to version 24.0

* Sun Jul 03 2022 wally <wally> 22.0-4.mga9
+ Revision: 1867230
- rebuild for boost 1.79.0

* Sun Apr 03 2022 umeabot <umeabot> 22.0-3.mga9
+ Revision: 1842802
- Mageia 9 Mass Rebuild

* Sun Dec 19 2021 wally <wally> 22.0-2.mga9
+ Revision: 1762678
- rebuild for boost 1.78.0

* Sat Sep 11 2021 wally <wally> 22.0-1.mga9
+ Revision: 1745197
- new version 22.0
- rebuild for boost 1.77.0

* Fri May 14 2021 wally <wally> 0.21.1-2.mga9
+ Revision: 1722939
- rebuild for boost 1.76.0

* Mon May 03 2021 daviddavid <daviddavid> 0.21.1-1.mga9
+ Revision: 1720999
- new version: 0.21.1

* Fri Mar 05 2021 daviddavid <daviddavid> 0.21.0-1.mga9
+ Revision: 1698773
- new version: 0.21.0

* Thu Dec 31 2020 wally <wally> 0.20.1-8.mga8
+ Revision: 1666737
- rebuild for boost 1.75.0

* Mon Dec 28 2020 luigiwalser <luigiwalser> 0.20.1-7.mga8
+ Revision: 1664479
- switch back to db53

* Sun Dec 20 2020 wally <wally> 0.20.1-6.mga8
+ Revision: 1661979
- rebuild for boost 1.74.0

* Fri Dec 18 2020 luigiwalser <luigiwalser> 0.20.1-5.mga8
+ Revision: 1660980
- rebuild for protobuf

* Wed Dec 16 2020 umeabot <umeabot> 0.20.1-4.mga8
+ Revision: 1658155
- Rebuild for new Qt5

* Mon Nov 30 2020 luigiwalser <luigiwalser> 0.20.1-3.mga8
+ Revision: 1650532
- rebuild for protobuf

* Thu Oct 29 2020 joequant <joequant> 0.20.1-2.mga8
+ Revision: 1640343
- fix build break

* Fri Jul 31 2020 kekepower <kekepower> 0.20.1-1.mga8
+ Revision: 1610043
- Update to version 0.20.1

* Sun Jun 28 2020 daviddavid <daviddavid> 0.20.0-1.mga8
+ Revision: 1600215
- new version: 0.20.0
- add upstream patch to fix build with Qt 5.15
- rebuild for new protobuf 3.12.3

* Sun May 03 2020 wally <wally> 0.19.1-2.mga8
+ Revision: 1578033
- rebuild for boost 1.73.0

* Thu Mar 05 2020 kekepower <kekepower> 0.19.1-1.mga8
+ Revision: 1553930
- Update to version 0.19.1

* Thu Feb 20 2020 umeabot <umeabot> 0.19.0.1-2.mga8
+ Revision: 1545099
- Mageia 8 Mass Rebuild

* Mon Jan 27 2020 daviddavid <daviddavid> 0.19.0.1-1.mga8
+ Revision: 1483784
- add upstream patch to fix build with boost 1.72.0
- new version: 0.19.0.1
+ wally <wally>
- rebuild for boost 1.72.0
- replace deprecated %%configure2_5x

* Thu Dec 19 2019 daviddavid <daviddavid> 0.18.1-2.mga8
+ Revision: 1468846
- rebuild for new protobuf 3.11.2

* Sun Sep 29 2019 daviddavid <daviddavid> 0.18.1-1.mga8
+ Revision: 1448007
- new version: 0.18.1

* Fri May 31 2019 joequant <joequant> 0.18.0-1.mga8
+ Revision: 1399399
- upgrade to 0.18.0

* Sat Mar 30 2019 umeabot <umeabot> 0.17.1-2.mga7
+ Revision: 1381320
- Qt5 Rebuild

* Mon Dec 31 2018 daviddavid <daviddavid> 0.17.1-1.mga7
+ Revision: 1347392
- new version: 0.17.1

* Sat Dec 29 2018 luigiwalser <luigiwalser> 0.16.3-3.mga7
+ Revision: 1346009
- rebuild for protobuf

* Tue Oct 16 2018 wally <wally> 0.16.3-2.mga7
+ Revision: 1321011
- rebuild for new boost 1.68.0

* Sat Oct 13 2018 daviddavid <daviddavid> 0.16.3-1.mga7
+ Revision: 1319984
- new version: 0.16.3, fixes CVE-2018-17144 (mga#23681)

* Fri Sep 21 2018 umeabot <umeabot> 0.16.2-2.mga7
+ Revision: 1295452
- Mageia 7 Mass Rebuild

* Fri Aug 24 2018 daviddavid <daviddavid> 0.16.2-1.mga7
+ Revision: 1253828
- new version: 0.16.2

* Thu May 17 2018 daviddavid <daviddavid> 0.16.0-1.mga7
+ Revision: 1229932
- new version: 0.16.0
- remove merged upstream patch
- add upstream desktop file and icons
- add upstream protocol file and bash completion

* Sun Apr 15 2018 daviddavid <daviddavid> 0.14.2-8.mga7
+ Revision: 1219024
- rebuild for new protobuf 3.5

* Mon Jan 08 2018 wally <wally> 0.14.2-7.mga7
+ Revision: 1191632
- add patch from upstream to fix build with boost 1.66
- rebuild for new boost

* Tue Nov 21 2017 tv <tv> 0.14.2-6.mga7
+ Revision: 1178096
- rebuild for boost 1.65

* Mon Oct 09 2017 daviddavid <daviddavid> 0.14.2-5.mga7
+ Revision: 1170405
- rebuild for new qrencode 4.0.0

* Sat Sep 16 2017 tv <tv> 0.14.2-4.mga7
+ Revision: 1154675
- rebuild with latest boost

* Mon Sep 04 2017 guillomovitch <guillomovitch> 0.14.2-3.mga7
+ Revision: 1151175
- rebuild with openssl 1.1

* Sat Jul 29 2017 dlucio <dlucio> 0.14.2-2.mga7
+ Revision: 1132226
- systemd unit service

* Fri Jul 28 2017 dlucio <dlucio> 0.14.2-1.mga7
+ Revision: 1132212
- 0.14.2
- new man files

* Tue May 16 2017 neoclust <neoclust> 0.12.0-3.mga6
+ Revision: 1102002
- Rebuild against new miniupnpc

* Thu Feb 16 2017 mrambo3501 <mrambo3501> 0.12.0-2.mga6
+ Revision: 1086459
- rebuild for new libevent

* Tue Mar 01 2016 fwang <fwang> 0.12.0-1.mga6
+ Revision: 981277
- update file list
- update file list
- update file list
- add more br
- 0.12.0

* Sat Feb 13 2016 umeabot <umeabot> 0.11.0-8.mga6
+ Revision: 959605
- Mageia 6 Mass Rebuild
- Mageia 6 Mass Rebuild

* Sat Dec 26 2015 daviddavid <daviddavid> 0.11.0-6.mga6
+ Revision: 915162
- rebuild for new boost 1.60.0
- add missing BR on pkgconfig(openssl)

* Mon Oct 19 2015 fwang <fwang> 0.11.0-5.mga6
+ Revision: 892635
- disable static
- update file name
- add desc
- add shared libs
- turn back to qt4 flavour
- force fpic
- build qt5 with fpic
- use qt5 version of lrelease
- adopt to new api of miniupnpc
- build qt5 flavour
- rebuild for new miniupnpc

* Fri Sep 25 2015 daviddavid <daviddavid> 0.11.0-4.mga6
+ Revision: 883654
- rebuild for new boost 1.59.0

* Thu Sep 03 2015 cjw <cjw> 0.11.0-3.mga6
+ Revision: 872419
- rebuild with gcc 5

* Fri Jul 31 2015 daviddavid <daviddavid> 0.11.0-2.mga6
+ Revision: 859863
- rebuild for new boost-1.58.0

* Sat Jul 25 2015 blino <blino> 0.11.0-1.mga6
+ Revision: 857684
- add bitcoinconsensus devel package
- remove .la file
- package bitcoin-cli man page
- package bitcoin-tx tool
- 0.11.0

* Mon Jan 12 2015 buchan <buchan> 0.9.3-1.mga5
+ Revision: 810038
- Fix BDB detection in cauldron
- Update to 0.9.3
- ship man pages, bash completions etc.

* Wed Dec 17 2014 sander85 <sander85> 0.8.6-5.mga5
+ Revision: 803772
- Rebuild for miniupnpc

* Wed Oct 15 2014 umeabot <umeabot> 0.8.6-4.mga5
+ Revision: 740966
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 0.8.6-3.mga5
+ Revision: 678161
- Mageia 5 Mass Rebuild

* Wed May 14 2014 luigiwalser <luigiwalser> 0.8.6-2.mga5
+ Revision: 622816
- rebuild for miniupnpc

* Fri Jan 03 2014 blino <blino> 0.8.6-1.mga5
+ Revision: 564126
- initial Mageia package (0.8.6)
- Created package structure for bitcoin.

